using System;
using System.Collections;
using System.Globalization;
using Microsoft.SqlServer.Server;


public class CTest : IEnumerator
{ 
	// class constructor
	public CTest (String strCultureName)
	{
		m_iMonth = 0;		
		m_DateTimeFormatInfo = DateTimeFormatInfo.GetInstance ((new CultureInfo(strCultureName)));
	}
	
	// Three IEnumerator methods.
	public bool 	MoveNext ()	{ return x_MonthsInYear != m_iMonth++; }
	public object 	Current 	{  get  { return this; } }
	public void 	Reset ()	{ m_iMonth = 0; }


	// Two Tvf contract methods
	[SqlFunctionAttribute (FillRowMethodName="FillRow")]
	public static IEnumerator InitMethod (String strCultureName)
	{
		return new CTest (strCultureName);
	}

	public static void FillRow (Object obj, out int iMonth, out String strMonth, out String strAbbreviatedMonth)
	{
		CTest cTest = (CTest)obj;

		iMonth 			= cTest.m_iMonth;
		strMonth 		= cTest.m_DateTimeFormatInfo.MonthNames [iMonth-1];
		strAbbreviatedMonth 	= cTest.m_DateTimeFormatInfo.AbbreviatedMonthNames [iMonth-1];
		
	}

	// Data members	
	int 				m_iMonth;
	DateTimeFormatInfo 		m_DateTimeFormatInfo;	
	public static readonly int 	x_MonthsInYear = 12;
}


